/**
 * EasyQRCodeJS
 * 
 * NodeJS QRCode generator. Save image to file. Support Dot style, Logo, Background image, Colorful, Title, etc.(Running without DOM on server side)
 * 
 * Version 3.5.1
 * 
 * @author [ inthinkcolor@gmail.com ]
 * 
 * @see https://github.com/ushelp/EasyQRCodeJS-NodeJS
 * @see http://www.easyproject.cn/easyqrcodejs/tryit.html
 * @see https://github.com/ushelp/EasyQRCodeJS
 * 
 * Copyright 2017 Ray, EasyProject
 * Released under the MIT license
 * 
 * [Node.js]
 * 
 */
'use strict';var _Mathround=Math.round,_Mathmax=Math.max,_Mathfloor=Math.floor,_require=require('canvas'),createCanvas=_require.createCanvas,loadImage=_require.loadImage,Image=_require.Image,fs=require('fs');function QR8bitByte(b){this.mode=QRMode.MODE_8BIT_BYTE,this.data=b,this.parsedData=[];for(var f=0,g=this.data.length;f<g;f++){var h=[],k=this.data.charCodeAt(f);65536<k?(h[0]=240|(1835008&k)>>>18,h[1]=128|(258048&k)>>>12,h[2]=128|(4032&k)>>>6,h[3]=128|63&k):2048<k?(h[0]=224|(61440&k)>>>12,h[1]=128|(4032&k)>>>6,h[2]=128|63&k):128<k?(h[0]=192|(1984&k)>>>6,h[1]=128|63&k):h[0]=k,this.parsedData.push(h)}this.parsedData=Array.prototype.concat.apply([],this.parsedData),this.parsedData.length!=this.data.length&&(this.parsedData.unshift(191),this.parsedData.unshift(187),this.parsedData.unshift(239))}QR8bitByte.prototype={getLength:function getLength(){return this.parsedData.length},write:function write(b){for(var f=0,g=this.parsedData.length;f<g;f++)b.put(this.parsedData[f],8)}};function QRCodeModel(b,f){this.typeNumber=b,this.errorCorrectLevel=f,this.modules=null,this.moduleCount=0,this.dataCache=null,this.dataList=[]}QRCodeModel.prototype={addData:function addData(b){var f=new QR8bitByte(b);this.dataList.push(f),this.dataCache=null},isDark:function isDark(b,f){if(0>b||this.moduleCount<=b||0>f||this.moduleCount<=f)throw new Error(b+','+f);return this.modules[b][f][0]},getEye:function getEye(b,f){if(0>b||this.moduleCount<=b||0>f||this.moduleCount<=f)throw new Error(b+','+f);var g=this.modules[b][f];if(g[1]){var h='P'+g[1]+'_'+g[2];return'A'==g[2]&&(h='A'+g[1]),{isDarkBlock:g[0],type:h}}return null},getModuleCount:function getModuleCount(){return this.moduleCount},make:function make(){this.makeImpl(!1,this.getBestMaskPattern())},makeImpl:function makeImpl(b,f){this.moduleCount=4*this.typeNumber+17,this.modules=Array(this.moduleCount);for(var g=0;g<this.moduleCount;g++){this.modules[g]=Array(this.moduleCount);for(var h=0;h<this.moduleCount;h++)this.modules[g][h]=[]}this.setupPositionProbePattern(0,0,'TL'),this.setupPositionProbePattern(this.moduleCount-7,0,'BL'),this.setupPositionProbePattern(0,this.moduleCount-7,'TR'),this.setupPositionAdjustPattern('A'),this.setupTimingPattern(),this.setupTypeInfo(b,f),7<=this.typeNumber&&this.setupTypeNumber(b),null==this.dataCache&&(this.dataCache=QRCodeModel.createData(this.typeNumber,this.errorCorrectLevel,this.dataList)),this.mapData(this.dataCache,f)},setupPositionProbePattern:function setupPositionProbePattern(b,f,g){for(var h=-1;7>=h;h++)if(!(-1>=b+h||this.moduleCount<=b+h))for(var k=-1;7>=k;k++)-1>=f+k||this.moduleCount<=f+k||(0<=h&&6>=h&&(0==k||6==k)||0<=k&&6>=k&&(0==h||6==h)||2<=h&&4>=h&&2<=k&&4>=k?(this.modules[b+h][f+k][0]=!0,this.modules[b+h][f+k][2]=g,this.modules[b+h][f+k][1]=-0==h||-0==k||6==h||6==k?'O':'I'):this.modules[b+h][f+k][0]=!1)},getBestMaskPattern:function getBestMaskPattern(){for(var b=0,f=0,g=0;8>g;g++){this.makeImpl(!0,g);var h=QRUtil.getLostPoint(this);(0==g||b>h)&&(b=h,f=g)}return f},createMovieClip:function createMovieClip(b,f,g){var h=b.createEmptyMovieClip(f,g),k=1;this.make();for(var o,m=0;m<this.modules.length;m++){o=m*k;for(var p=0;p<this.modules[m].length;p++){var q=p*k,s=this.modules[m][p][0];s&&(h.beginFill(0,100),h.moveTo(q,o),h.lineTo(q+k,o),h.lineTo(q+k,o+k),h.lineTo(q,o+k),h.endFill())}}return h},setupTimingPattern:function setupTimingPattern(){for(var b=8;b<this.moduleCount-8;b++)null==this.modules[b][6][0]&&(this.modules[b][6][0]=0==b%2);for(var f=8;f<this.moduleCount-8;f++)null==this.modules[6][f][0]&&(this.modules[6][f][0]=0==f%2)},setupPositionAdjustPattern:function setupPositionAdjustPattern(b){for(var f=QRUtil.getPatternPosition(this.typeNumber),g=0;g<f.length;g++)for(var h=0;h<f.length;h++){var k=f[g],m=f[h];if(null==this.modules[k][m][0])for(var o=-2;2>=o;o++)for(var p=-2;2>=p;p++)-2==o||2==o||-2==p||2==p||0==o&&0==p?(this.modules[k+o][m+p][0]=!0,this.modules[k+o][m+p][2]=b,this.modules[k+o][m+p][1]=-2==o||-2==p||2==o||2==p?'O':'I'):this.modules[k+o][m+p][0]=!1}},setupTypeNumber:function setupTypeNumber(b){for(var h,f=QRUtil.getBCHTypeNumber(this.typeNumber),g=0;18>g;g++)h=!b&&1==(1&f>>g),this.modules[_Mathfloor(g/3)][g%3+this.moduleCount-8-3][0]=h;for(var h,g=0;18>g;g++)h=!b&&1==(1&f>>g),this.modules[g%3+this.moduleCount-8-3][_Mathfloor(g/3)][0]=h},setupTypeInfo:function setupTypeInfo(b,f){for(var m,g=this.errorCorrectLevel<<3|f,h=QRUtil.getBCHTypeInfo(g),k=0;15>k;k++)m=!b&&1==(1&h>>k),6>k?this.modules[k][8][0]=m:8>k?this.modules[k+1][8][0]=m:this.modules[this.moduleCount-15+k][8][0]=m;for(var m,k=0;15>k;k++)m=!b&&1==(1&h>>k),8>k?this.modules[8][this.moduleCount-k-1][0]=m:9>k?this.modules[8][15-k-1+1][0]=m:this.modules[8][15-k-1][0]=m;this.modules[this.moduleCount-8][8][0]=!b},mapData:function mapData(b,f){for(var g=-1,h=this.moduleCount-1,k=7,m=0,o=this.moduleCount-1;0<o;o-=2)for(6==o&&o--;;){for(var p=0;2>p;p++)if(null==this.modules[h][o-p][0]){var q=!1;m<b.length&&(q=1==(1&b[m]>>>k));var s=QRUtil.getMask(f,h,o-p);s&&(q=!q),this.modules[h][o-p][0]=q,k--,-1==k&&(m++,k=7)}if(h+=g,0>h||this.moduleCount<=h){h-=g,g=-g;break}}}},QRCodeModel.PAD0=236,QRCodeModel.PAD1=17,QRCodeModel.createData=function(b,f,g){for(var o,h=QRRSBlock.getRSBlocks(b,f),k=new QRBitBuffer,m=0;m<g.length;m++)o=g[m],k.put(o.mode,4),k.put(o.getLength(),QRUtil.getLengthInBits(o.mode,b)),o.write(k);for(var p=0,m=0;m<h.length;m++)p+=h[m].dataCount;if(k.getLengthInBits()>8*p)throw new Error('code length overflow. ('+k.getLengthInBits()+'>'+8*p+')');for(k.getLengthInBits()+4<=8*p&&k.put(0,4);0!=k.getLengthInBits()%8;)k.putBit(!1);for(;!(k.getLengthInBits()>=8*p)&&!(k.put(QRCodeModel.PAD0,8),k.getLengthInBits()>=8*p);)k.put(QRCodeModel.PAD1,8);return QRCodeModel.createBytes(k,h)},QRCodeModel.createBytes=function(b,f){for(var g=0,h=0,k=0,m=Array(f.length),o=Array(f.length),p=0;p<f.length;p++){var q=f[p].dataCount,s=f[p].totalCount-q;h=_Mathmax(h,q),k=_Mathmax(k,s),m[p]=Array(q);for(var u=0;u<m[p].length;u++)m[p][u]=255&b.buffer[u+g];g+=q;var v=QRUtil.getErrorCorrectPolynomial(s),w=new QRPolynomial(m[p],v.getLength()-1),z=w.mod(v);o[p]=Array(v.getLength()-1);for(var A,u=0;u<o[p].length;u++)A=u+z.getLength()-o[p].length,o[p][u]=0<=A?z.get(A):0}for(var B=0,u=0;u<f.length;u++)B+=f[u].totalCount;for(var C=Array(B),D=0,u=0;u<h;u++)for(var p=0;p<f.length;p++)u<m[p].length&&(C[D++]=m[p][u]);for(var u=0;u<k;u++)for(var p=0;p<f.length;p++)u<o[p].length&&(C[D++]=o[p][u]);return C};for(var QRMode={MODE_NUMBER:1,MODE_ALPHA_NUM:2,MODE_8BIT_BYTE:4,MODE_KANJI:8},QRErrorCorrectLevel={L:1,M:0,Q:3,H:2},QRMaskPattern={PATTERN000:0,PATTERN001:1,PATTERN010:2,PATTERN011:3,PATTERN100:4,PATTERN101:5,PATTERN110:6,PATTERN111:7},QRUtil={PATTERN_POSITION_TABLE:[[],[6,18],[6,22],[6,26],[6,30],[6,34],[6,22,38],[6,24,42],[6,26,46],[6,28,50],[6,30,54],[6,32,58],[6,34,62],[6,26,46,66],[6,26,48,70],[6,26,50,74],[6,30,54,78],[6,30,56,82],[6,30,58,86],[6,34,62,90],[6,28,50,72,94],[6,26,50,74,98],[6,30,54,78,102],[6,28,54,80,106],[6,32,58,84,110],[6,30,58,86,114],[6,34,62,90,118],[6,26,50,74,98,122],[6,30,54,78,102,126],[6,26,52,78,104,130],[6,30,56,82,108,134],[6,34,60,86,112,138],[6,30,58,86,114,142],[6,34,62,90,118,146],[6,30,54,78,102,126,150],[6,24,50,76,102,128,154],[6,28,54,80,106,132,158],[6,32,58,84,110,136,162],[6,26,54,82,110,138,166],[6,30,58,86,114,142,170]],G15:1335,G18:7973,G15_MASK:21522,getBCHTypeInfo:function getBCHTypeInfo(b){for(var f=b<<10;0<=QRUtil.getBCHDigit(f)-QRUtil.getBCHDigit(QRUtil.G15);)f^=QRUtil.G15<<QRUtil.getBCHDigit(f)-QRUtil.getBCHDigit(QRUtil.G15);return(b<<10|f)^QRUtil.G15_MASK},getBCHTypeNumber:function getBCHTypeNumber(b){for(var f=b<<12;0<=QRUtil.getBCHDigit(f)-QRUtil.getBCHDigit(QRUtil.G18);)f^=QRUtil.G18<<QRUtil.getBCHDigit(f)-QRUtil.getBCHDigit(QRUtil.G18);return b<<12|f},getBCHDigit:function getBCHDigit(b){for(var f=0;0!=b;)f++,b>>>=1;return f},getPatternPosition:function getPatternPosition(b){return QRUtil.PATTERN_POSITION_TABLE[b-1]},getMask:function getMask(b,f,g){switch(b){case QRMaskPattern.PATTERN000:return 0==(f+g)%2;case QRMaskPattern.PATTERN001:return 0==f%2;case QRMaskPattern.PATTERN010:return 0==g%3;case QRMaskPattern.PATTERN011:return 0==(f+g)%3;case QRMaskPattern.PATTERN100:return 0==(_Mathfloor(f/2)+_Mathfloor(g/3))%2;case QRMaskPattern.PATTERN101:return 0==f*g%2+f*g%3;case QRMaskPattern.PATTERN110:return 0==(f*g%2+f*g%3)%2;case QRMaskPattern.PATTERN111:return 0==(f*g%3+(f+g)%2)%2;default:throw new Error('bad maskPattern:'+b);}},getErrorCorrectPolynomial:function getErrorCorrectPolynomial(b){for(var f=new QRPolynomial([1],0),g=0;g<b;g++)f=f.multiply(new QRPolynomial([1,QRMath.gexp(g)],0));return f},getLengthInBits:function getLengthInBits(b,f){if(1<=f&&10>f)switch(b){case QRMode.MODE_NUMBER:return 10;case QRMode.MODE_ALPHA_NUM:return 9;case QRMode.MODE_8BIT_BYTE:return 8;case QRMode.MODE_KANJI:return 8;default:throw new Error('mode:'+b);}else if(27>f)switch(b){case QRMode.MODE_NUMBER:return 12;case QRMode.MODE_ALPHA_NUM:return 11;case QRMode.MODE_8BIT_BYTE:return 16;case QRMode.MODE_KANJI:return 10;default:throw new Error('mode:'+b);}else if(41>f)switch(b){case QRMode.MODE_NUMBER:return 14;case QRMode.MODE_ALPHA_NUM:return 13;case QRMode.MODE_8BIT_BYTE:return 16;case QRMode.MODE_KANJI:return 12;default:throw new Error('mode:'+b);}else throw new Error('type:'+f)},getLostPoint:function getLostPoint(b){for(var f=b.getModuleCount(),g=0,h=0;h<f;h++)for(var k=0;k<f;k++){for(var m=0,o=b.isDark(h,k),p=-1;1>=p;p++)if(!(0>h+p||f<=h+p))for(var q=-1;1>=q;q++)0>k+q||f<=k+q||(0!=p||0!=q)&&o==b.isDark(h+p,k+q)&&m++;5<m&&(g+=3+m-5)}for(var h=0;h<f-1;h++)for(var s,k=0;k<f-1;k++)s=0,b.isDark(h,k)&&s++,b.isDark(h+1,k)&&s++,b.isDark(h,k+1)&&s++,b.isDark(h+1,k+1)&&s++,(0==s||4==s)&&(g+=3);for(var h=0;h<f;h++)for(var k=0;k<f-6;k++)b.isDark(h,k)&&!b.isDark(h,k+1)&&b.isDark(h,k+2)&&b.isDark(h,k+3)&&b.isDark(h,k+4)&&!b.isDark(h,k+5)&&b.isDark(h,k+6)&&(g+=40);for(var k=0;k<f;k++)for(var h=0;h<f-6;h++)b.isDark(h,k)&&!b.isDark(h+1,k)&&b.isDark(h+2,k)&&b.isDark(h+3,k)&&b.isDark(h+4,k)&&!b.isDark(h+5,k)&&b.isDark(h+6,k)&&(g+=40);for(var u=0,k=0;k<f;k++)for(var h=0;h<f;h++)b.isDark(h,k)&&u++;var v=Math.abs(100*u/f/f-50)/5;return g+=10*v,g}},QRMath={glog:function glog(b){if(1>b)throw new Error('glog('+b+')');return QRMath.LOG_TABLE[b]},gexp:function gexp(b){for(;0>b;)b+=255;for(;256<=b;)b-=255;return QRMath.EXP_TABLE[b]},EXP_TABLE:Array(256),LOG_TABLE:Array(256)},i=0;8>i;i++)QRMath.EXP_TABLE[i]=1<<i;for(var i=8;256>i;i++)QRMath.EXP_TABLE[i]=QRMath.EXP_TABLE[i-4]^QRMath.EXP_TABLE[i-5]^QRMath.EXP_TABLE[i-6]^QRMath.EXP_TABLE[i-8];for(var i=0;255>i;i++)QRMath.LOG_TABLE[QRMath.EXP_TABLE[i]]=i;function QRPolynomial(b,f){if(b.length==void 0)throw new Error(b.length+'/'+f);for(var g=0;g<b.length&&0==b[g];)g++;this.num=Array(b.length-g+f);for(var h=0;h<b.length-g;h++)this.num[h]=b[h+g]}QRPolynomial.prototype={get:function get(b){return this.num[b]},getLength:function getLength(){return this.num.length},multiply:function multiply(b){for(var f=Array(this.getLength()+b.getLength()-1),g=0;g<this.getLength();g++)for(var h=0;h<b.getLength();h++)f[g+h]^=QRMath.gexp(QRMath.glog(this.get(g))+QRMath.glog(b.get(h)));return new QRPolynomial(f,0)},mod:function mod(b){if(0>this.getLength()-b.getLength())return this;for(var f=QRMath.glog(this.get(0))-QRMath.glog(b.get(0)),g=Array(this.getLength()),h=0;h<this.getLength();h++)g[h]=this.get(h);for(var h=0;h<b.getLength();h++)g[h]^=QRMath.gexp(QRMath.glog(b.get(h))+f);return new QRPolynomial(g,0).mod(b)}};function QRRSBlock(b,f){this.totalCount=b,this.dataCount=f}QRRSBlock.RS_BLOCK_TABLE=[[1,26,19],[1,26,16],[1,26,13],[1,26,9],[1,44,34],[1,44,28],[1,44,22],[1,44,16],[1,70,55],[1,70,44],[2,35,17],[2,35,13],[1,100,80],[2,50,32],[2,50,24],[4,25,9],[1,134,108],[2,67,43],[2,33,15,2,34,16],[2,33,11,2,34,12],[2,86,68],[4,43,27],[4,43,19],[4,43,15],[2,98,78],[4,49,31],[2,32,14,4,33,15],[4,39,13,1,40,14],[2,121,97],[2,60,38,2,61,39],[4,40,18,2,41,19],[4,40,14,2,41,15],[2,146,116],[3,58,36,2,59,37],[4,36,16,4,37,17],[4,36,12,4,37,13],[2,86,68,2,87,69],[4,69,43,1,70,44],[6,43,19,2,44,20],[6,43,15,2,44,16],[4,101,81],[1,80,50,4,81,51],[4,50,22,4,51,23],[3,36,12,8,37,13],[2,116,92,2,117,93],[6,58,36,2,59,37],[4,46,20,6,47,21],[7,42,14,4,43,15],[4,133,107],[8,59,37,1,60,38],[8,44,20,4,45,21],[12,33,11,4,34,12],[3,145,115,1,146,116],[4,64,40,5,65,41],[11,36,16,5,37,17],[11,36,12,5,37,13],[5,109,87,1,110,88],[5,65,41,5,66,42],[5,54,24,7,55,25],[11,36,12],[5,122,98,1,123,99],[7,73,45,3,74,46],[15,43,19,2,44,20],[3,45,15,13,46,16],[1,135,107,5,136,108],[10,74,46,1,75,47],[1,50,22,15,51,23],[2,42,14,17,43,15],[5,150,120,1,151,121],[9,69,43,4,70,44],[17,50,22,1,51,23],[2,42,14,19,43,15],[3,141,113,4,142,114],[3,70,44,11,71,45],[17,47,21,4,48,22],[9,39,13,16,40,14],[3,135,107,5,136,108],[3,67,41,13,68,42],[15,54,24,5,55,25],[15,43,15,10,44,16],[4,144,116,4,145,117],[17,68,42],[17,50,22,6,51,23],[19,46,16,6,47,17],[2,139,111,7,140,112],[17,74,46],[7,54,24,16,55,25],[34,37,13],[4,151,121,5,152,122],[4,75,47,14,76,48],[11,54,24,14,55,25],[16,45,15,14,46,16],[6,147,117,4,148,118],[6,73,45,14,74,46],[11,54,24,16,55,25],[30,46,16,2,47,17],[8,132,106,4,133,107],[8,75,47,13,76,48],[7,54,24,22,55,25],[22,45,15,13,46,16],[10,142,114,2,143,115],[19,74,46,4,75,47],[28,50,22,6,51,23],[33,46,16,4,47,17],[8,152,122,4,153,123],[22,73,45,3,74,46],[8,53,23,26,54,24],[12,45,15,28,46,16],[3,147,117,10,148,118],[3,73,45,23,74,46],[4,54,24,31,55,25],[11,45,15,31,46,16],[7,146,116,7,147,117],[21,73,45,7,74,46],[1,53,23,37,54,24],[19,45,15,26,46,16],[5,145,115,10,146,116],[19,75,47,10,76,48],[15,54,24,25,55,25],[23,45,15,25,46,16],[13,145,115,3,146,116],[2,74,46,29,75,47],[42,54,24,1,55,25],[23,45,15,28,46,16],[17,145,115],[10,74,46,23,75,47],[10,54,24,35,55,25],[19,45,15,35,46,16],[17,145,115,1,146,116],[14,74,46,21,75,47],[29,54,24,19,55,25],[11,45,15,46,46,16],[13,145,115,6,146,116],[14,74,46,23,75,47],[44,54,24,7,55,25],[59,46,16,1,47,17],[12,151,121,7,152,122],[12,75,47,26,76,48],[39,54,24,14,55,25],[22,45,15,41,46,16],[6,151,121,14,152,122],[6,75,47,34,76,48],[46,54,24,10,55,25],[2,45,15,64,46,16],[17,152,122,4,153,123],[29,74,46,14,75,47],[49,54,24,10,55,25],[24,45,15,46,46,16],[4,152,122,18,153,123],[13,74,46,32,75,47],[48,54,24,14,55,25],[42,45,15,32,46,16],[20,147,117,4,148,118],[40,75,47,7,76,48],[43,54,24,22,55,25],[10,45,15,67,46,16],[19,148,118,6,149,119],[18,75,47,31,76,48],[34,54,24,34,55,25],[20,45,15,61,46,16]],QRRSBlock.getRSBlocks=function(b,f){var g=QRRSBlock.getRsBlockTable(b,f);if(g==void 0)throw new Error('bad rs block @ typeNumber:'+b+'/errorCorrectLevel:'+f);for(var h=g.length/3,k=[],m=0;m<h;m++)for(var o=g[3*m+0],p=g[3*m+1],q=g[3*m+2],s=0;s<o;s++)k.push(new QRRSBlock(p,q));return k},QRRSBlock.getRsBlockTable=function(b,f){return f===QRErrorCorrectLevel.L?QRRSBlock.RS_BLOCK_TABLE[4*(b-1)+0]:f===QRErrorCorrectLevel.M?QRRSBlock.RS_BLOCK_TABLE[4*(b-1)+1]:f===QRErrorCorrectLevel.Q?QRRSBlock.RS_BLOCK_TABLE[4*(b-1)+2]:f===QRErrorCorrectLevel.H?QRRSBlock.RS_BLOCK_TABLE[4*(b-1)+3]:void 0};function QRBitBuffer(){this.buffer=[],this.length=0}QRBitBuffer.prototype={get:function get(b){var f=_Mathfloor(b/8);return 1==(1&this.buffer[f]>>>7-b%8)},put:function put(b,f){for(var g=0;g<f;g++)this.putBit(1==(1&b>>>f-g-1))},getLengthInBits:function getLengthInBits(){return this.length},putBit:function putBit(b){var f=_Mathfloor(this.length/8);this.buffer.length<=f&&this.buffer.push(0),b&&(this.buffer[f]|=128>>>this.length%8),this.length++}};var QRCodeLimitLength=[[17,14,11,7],[32,26,20,14],[53,42,32,24],[78,62,46,34],[106,84,60,44],[134,106,74,58],[154,122,86,64],[192,152,108,84],[230,180,130,98],[271,213,151,119],[321,251,177,137],[367,287,203,155],[425,331,241,177],[458,362,258,194],[520,412,292,220],[586,450,322,250],[644,504,364,280],[718,560,394,310],[792,624,442,338],[858,666,482,382],[929,711,509,403],[1003,779,565,439],[1091,857,611,461],[1171,911,661,511],[1273,997,715,535],[1367,1059,751,593],[1465,1125,805,625],[1528,1190,868,658],[1628,1264,908,698],[1732,1370,982,742],[1840,1452,1030,790],[1952,1538,1112,842],[2068,1628,1168,898],[2188,1722,1228,958],[2303,1809,1283,983],[2431,1911,1351,1051],[2563,1989,1423,1093],[2699,2099,1499,1139],[2809,2213,1579,1219],[2953,2331,1663,1273]];function _getTypeNumber(b,f){for(var p,g=f.correctLevel,h=1,k=_getUTF8Length(b),m=0,o=QRCodeLimitLength.length;m<=o&&(p=0,g===QRErrorCorrectLevel.L?p=QRCodeLimitLength[m][0]:g===QRErrorCorrectLevel.M?p=QRCodeLimitLength[m][1]:g===QRErrorCorrectLevel.Q?p=QRCodeLimitLength[m][2]:g===QRErrorCorrectLevel.H?p=QRCodeLimitLength[m][3]:void 0,!(k<=p));m++)h++;if(h>QRCodeLimitLength.length)throw new Error('Too long data');return 0!=f.version&&(h<=f.version?(h=f.version,f.runVersion=h):(console.warn('QR Code version '+f.version+' too small, run version use '+h),f.runVersion=h)),h}function _getUTF8Length(b){var f=encodeURI(b).toString().replace(/\%[0-9a-fA-F]{2}/g,'a');return f.length+(f.length==b?0:3)}var Drawing=function(b){this._bIsPainted=!1,this._htOption=b,this._canvas=createCanvas(200,200),this._oContext=this._canvas.getContext('2d'),this._oContext.patternQuality='best',this._oContext.quality='best',this._oContext.textDrawingMode='path',this._oContext.antialias='gray',this._bSupportDataURI=null};Drawing.prototype.draw=function(b){function f(){h.lineWidth=0,h.fillStyle=k.quietZoneColor,h.fillRect(0,0,v._canvas.width,k.quietZone),h.fillRect(0,k.quietZone,k.quietZone,v._canvas.height-2*k.quietZone),h.fillRect(v._canvas.width-k.quietZone,k.quietZone,k.quietZone,v._canvas.height-2*k.quietZone),h.fillRect(0,v._canvas.height-k.quietZone,v._canvas.width,k.quietZone)}function g(z){for(var A=0;A<m;A++)for(var B=0;B<m;B++){var C=B*o+k.quietZone,D=A*p+k.quietZone,E=z.isDark(A,B),F=z.getEye(A,B);if(F){E=F.isDarkBlock;var G=F.type,H=k[G]||k[G.substring(0,2)]||k.colorDark;h.lineWidth=0,h.strokeStyle=E?H:k.colorLight,h.fillStyle=E?H:k.colorLight,h.fillRect(C,k.titleHeight+D,o,p)}else{h.lineWidth=0,h.strokeStyle=E?k.colorDark:k.colorLight,h.fillStyle=E?k.colorDark:k.colorLight;var I=k.dotScale;if(6==A){I=1;var J=k.timing_H||k.timing||k.colorDark;h.fillStyle=E?J:k.colorLight,h.strokeStyle=h.fillStyle,h.fillRect(C+o*(1-I)/2,k.titleHeight+D+p*(1-I)/2,o*I,p*I)}else if(6==B){I=1;var K=k.timing_V||k.timing||k.colorDark;h.fillStyle=E?K:k.colorLight,h.strokeStyle=h.fillStyle,h.fillRect(C+o*(1-I)/2,k.titleHeight+D+p*(1-I)/2,o*I,p*I)}else k.backgroundImage?(k.autoColor?(h.strokeStyle=E?q:s,h.fillStyle=E?q:s):(h.fillStyle=E?k.colorDark:k.colorLight,h.strokeStyle=h.fillStyle),h.fillRect(C+o*(1-I)/2,k.titleHeight+D+p*(1-I)/2,o*I,p*I)):(h.strokeStyle=h.fillStyle,h.fillRect(C+o*(1-I)/2,k.titleHeight+D+p*(1-I)/2,o*I,p*I))}1==k.dotScale||F||(h.strokeStyle=k.colorLight)}if(k.title&&(h.fillStyle=k.titleBackgroundColor,h.fillRect(0,0,v._canvas.width,k.titleHeight+this._htOption.quietZone),h.font=k.titleFont,h.fillStyle=k.titleColor,h.textAlign='center',h.fillText(k.title,v._canvas.width/2,this._htOption.quietZone+30)),k.subTitle&&(h.font=k.subTitleFont,h.fillStyle=k.subTitleColor,h.fillText(k.subTitle,v._canvas.width/2,this._htOption.quietZone+60)),k.logo){var N=function genratorImg(){var O=_Mathround(k.width/3.5),P=_Mathround(k.height/3.5);O!=P&&(O=P),k.logoWidth&&(O=_Mathround(k.logoWidth)),k.logoHeight&&(P=_Mathround(k.logoHeight)),k.logoBackgroundTransparent||(h.fillStyle=k.logoBackgroundColor,h.fillRect((k.width+2*k.quietZone-O)/2,(k.height+k.titleHeight+2*k.quietZone-P)/2,O,O)),h.drawImage(L,(k.width+2*k.quietZone-O)/2,(k.height+k.titleHeight+2*k.quietZone-P)/2,O,P),M._bIsPainted=!0,0<k.quietZone&&k.quietZoneColor&&f(),M.makeImage()},L=new Image;L.src=k.logo;var M=this;if(L.onload=function(){N()},L.onerror=function(O){console.error(O)},L.complete)return L.onload=null,void N()}else this._bIsPainted=!0,0<k.quietZone&&k.quietZoneColor&&f(),this.makeImage()}var h=this._oContext,k=this._htOption;k.title||k.subTitle||(k.height-=k.titleHeight,k.titleHeight=0);var m=b.getModuleCount(),o=_Mathround(k.width/m),p=_Mathround((k.height-k.titleHeight)/m);k.quietZone=_Mathround(k.quietZone),this._htOption.width=o*m,this._htOption.height=p*m+k.titleHeight,this._canvas.width=this._htOption.width+2*this._htOption.quietZone,this._canvas.height=this._htOption.height+2*this._htOption.quietZone;var q='rgba(0, 0, 0, .6)',s='rgba(255, 255, 255, .7)',u='rgba(0,0,0,0)';'JPG'==k.format&&('transparent'==k.quietZoneColor&&(k.quietZoneColor='#ffffff'),k.logoBackgroundTransparent=!1,q=k.colorDark,s=k.colorLight,u=k.colorLight,h.fillStyle='#ffffff',h.fillRect(0,0,this._canvas.width,this._canvas.height));var v=this;if(k.backgroundImage){var w=new Image;w.onload=function(){h.globalAlpha=1,h.globalAlpha=k.backgroundImageAlpha,h.drawImage(w,0,k.titleHeight,k.width+2*k.quietZone,k.height+2*k.quietZone-k.titleHeight),h.globalAlpha=1,g.call(v,b)},w.src=k.backgroundImage}else g.call(v,b)},Drawing.prototype.makeImage=function(){var b=this.makeOptions,f=this;if('FILE'==b.makeType){this._htOption.onRenderingStart&&this._htOption.onRenderingStart(this._htOption);var g=fs.createWriteStream(b.path),h;h='PNG'==this._htOption.format?this._canvas.createPNGStream({compressionLevel:this._htOption.compressionLevel}):this._canvas.createJPEGStream({quality:this._htOption.quality}),h.pipe(g),g.on('finish',function(){f.resolve({})})}else'URL'==b.makeType&&(this._htOption.onRenderingStart&&this._htOption.onRenderingStart(this._htOption),'PNG'==this._htOption.format?this._canvas.toDataURL(function(k,m){f.resolve(m)}):this._canvas.toDataURL('image/jpeg',function(k,m){f.resolve(m)}))},Drawing.prototype.isPainted=function(){return this._bIsPainted},Drawing.prototype.round=function(b){return b?_Mathfloor(1e3*b)/1e3:b};function QRCode(b){if(this._htOption={width:256,height:256,typeNumber:4,colorDark:'#000000',colorLight:'#ffffff',correctLevel:QRErrorCorrectLevel.H,dotScale:1,quietZone:0,quietZoneColor:'transparent',title:'',titleFont:'bold 16px Arial',titleColor:'#000000',titleBackgroundColor:'#ffffff',titleHeight:0,titleTop:30,subTitle:'',subTitleFont:'14px Arial',subTitleColor:'#4F4F4F',subTitleTop:0,logo:void 0,logoWidth:void 0,logoHeight:void 0,logoBackgroundColor:'#ffffff',logoBackgroundTransparent:!1,PO:void 0,PI:void 0,PO_TL:void 0,PI_TL:void 0,PO_TR:void 0,PI_TR:void 0,PO_BL:void 0,PI_BL:void 0,AO:void 0,AI:void 0,timing:void 0,timing_H:void 0,timing_V:void 0,backgroundImage:void 0,backgroundImageAlpha:1,autoColor:!1,onRenderingStart:void 0,format:'PNG',compressionLevel:6,quality:0.75,version:0},'string'==typeof b&&(b={text:b}),b)for(var f in b)this._htOption[f]=b[f];(0>this._htOption.version||40<this._htOption.version)&&(console.warn('QR Code version \''+this._htOption.version+'\' is invalidate, reset to 0'),this._htOption.version=0),this._htOption.format=this._htOption.format.toUpperCase(),'PNG'!=this._htOption.format&&'JPG'!=this._htOption.format&&(console.warn('Image format \''+this._htOption.format+'\' is invalidate, reset to \'PNG\''),this._htOption.format='PNG'),'PNG'==this._htOption.format&&(0>this._htOption.compressionLevel||9<this._htOption.compressionLevel)?(console.warn(this._htOption.compressionLevel+' is invalidate, PNG compressionLevel must between 0 and 9, now reset to 6. '),this._htOption.compressionLevel=1):(0>this._htOption.quality||1<this._htOption.quality)&&(console.warn(this._htOption.quality+' is invalidate, JPG quality must between 0 and 1, now reset to 0.75. '),this._htOption.quality=0.75),(0>this._htOption.dotScale||1<this._htOption.dotScale)&&(console.warn(this._htOption.dotScale+' , is invalidate, dotScale must greater than 0, less than or equal to 1, now reset to 1. '),this._htOption.dotScale=1),(0>this._htOption.backgroundImageAlpha||1<this._htOption.backgroundImageAlpha)&&(console.warn(this._htOption.backgroundImageAlpha+' , is invalidate, backgroundImageAlpha must between 0 and 1, now reset to 1. '),this._htOption.backgroundImageAlpha=1),this._htOption.height+=this._htOption.titleHeight,this._oQRCode=null,this._oQRCode=new QRCodeModel(_getTypeNumber(this._htOption.text,this._htOption),this._htOption.correctLevel),this._oQRCode.addData(this._htOption.text),this._oQRCode.make()}QRCode.prototype.saveImage=function(b){b=Object.assign({makeType:'FILE',path:null},b);var g=new Drawing(this._htOption);g.makeOptions=b;try{var h=this;return new Promise(function(k){g.resolve=k,g.draw(h._oQRCode)})}catch(k){console.error(k)}},QRCode.prototype.toDataURL=function(){var g=new Drawing(this._htOption);g.makeOptions={makeType:'URL'};try{var h=this;return new Promise(function(k){g.resolve=k,g.draw(h._oQRCode)})}catch(k){console.error(k)}},QRCode.CorrectLevel=QRErrorCorrectLevel,module.exports=QRCode;
